;---------------------------------------------
; Cut Man
;---------------------------------------------
; clear - drop goal item
; set   - drop teleport item
;---------------------------------------------
!jump_power = $06
!fire_power = $03
!cape_power = $03
!item_power = $0F
!kattaanohayasa = $40
!taositekaranojikan = $80
;---------------------------------------------
WalkingXSpeed:
    db $18,$E8
move_table:
	db $78,$30,$78,$C0
speed_table:
	db $E8,$E8,$18,$18
anime_table:
	db $05,$06,$07
	db $06,$05,$04
walkinganime:
	db $02,$03,$04,$05,$06,$07
;---------------------------------------------
; do not change it
;---------------------------------------------
!pose = !1504
!state = !1510
!hasami_flag = !151C
!timer = !1540
!anime_count = !1602
!muteki = !1558
;---------------------------------------------
; sprite
;---------------------------------------------
print "INIT ",pc
	LDA #$08
	STA !pose,x
	%SubHorzPos()
	TYA
	STA $157C,x
	RTL
;---------------------------------------------
print "MAIN ",pc
	PHB
	PHK
	PLB
	JSR +
	PLB
	RTL
;---------------------------------------------
+
	LDA #$00
	%SubOffScreen()
	JSR gfx
	
	LDA $9D
	BNE return
	LDA !sprite_status,x
	CMP #$08
	BNE return

	LDA !state,x
	CMP #$03
	BNE +
	LDA $14
	BNE +
	LDA #$04
	STA !state,x
	LDA #$09
	STA !pose,x
+

	LDA !state,x
	JSL $0086DF|!BankB
	dw wait,posing,hpup,walking,cutterthrow,deffert
;---------------------------------------------
wait:
	%SubHorzPos()
	TYA
	STA !157C,x
	LDA !sprite_x_high,x
	CMP $95
	BNE +
	LDA $77
	AND #$04
	BEQ +
	LDA #$0B
	STA $71
	JSL $01802A|!BankB
	LDA !sprite_blocked_status,x
	AND #$04
	BEQ +
	STZ !pose,x
	INC !state,x
	LDA #$10
	STA !timer,x
+
return:
	RTS
;---------------------------------------------
posing:
	LDA !timer,x
	BNE +
	LDA !anime_count,x
	CMP #$07
	BCS ++
	AND #$01
	STA !pose,x
	STA !hasami_flag,x
	LDA #$08
	STA !timer,x
	INC !anime_count,x
+
	RTS
++
	STZ $00
	LDA #$C0
	STA $01
	STZ $02
	STZ $03
	LDA !new_sprite_num,x
	DEC A
	SEC
	%SpawnSprite()
	TXA
	STA !C2,y
	INC !state,x
	LDA #$10
	STA !timer,x
	RTS
;---------------------------------------------
hpup:
	LDA !timer,x
	BNE +
	LDA !C2,x
	INC A
	STA !C2,x
	LDA !C2,x
	CMP #$1C
	BCS ++
	LDA #$01
	STA $1DFC|!Base2
	LDA #$02
	STA !timer,x
+
	RTS
++
	INC !state,x
	LDA #$10
	STA !timer,x
	STZ $71
-
	RTS
;---------------------------------------------
walking:
	LDA !1588,x
	PHA
	AND #$03
	BEQ +
	STZ !sprite_speed_x,x
+
	PLA
	AND #$08
	BEQ +
	STZ !sprite_speed_y,x
+
	JSL $01802A|!BankB
	JSR check_mario
	LDA !state,x
	CMP #$05
	BNE +
	RTS
+
	LDA !sprite_blocked_status,x
	AND #$04
	BEQ ++
	%SubHorzPos()
	TYA
	STA !157C,x
	LDA !sprite_blocked_status,x
	AND #$03
	BEQ +
	LDA #$C8
-:
	STA !sprite_speed_y,x
	LDA #$08
	STA !pose,x
	LDA !hasami_flag,x
	CMP #$02
	BEQ as
	LDA $14
	AND #$01
	STA !hasami_flag,x
as:
	RTS
+:
	LDA WalkingXSpeed,y
	STA !sprite_speed_x,x
	REP #$20
	LDA $0E
	BPL +
	EOR #$FFFF
	INC
+:
	CMP #$0030
	SEP #$20
	BCS +
	LDA #$A6
	BRA -
+:
	INC !1570,x
	LDA !1570,x
	CMP #$08
	BCC ++
	STZ !1570,x
	INC !anime_count,x
	LDA #$FF
	LDA !anime_count,x
	CMP #$06
	BCC +
	STZ !anime_count,x
+
	LDA !anime_count,x
	CLC
	ADC #$02
	STA !pose,x
++
	LDA #$10
	%Random()
	CLC
	ADC #$10
	STA !timer,x

	RTS
;---------------------------------------------
cutterthrow:
	LDA !1588,x
	PHA
	AND #$03
	BEQ +
	STZ !sprite_speed_x,x
+
	PLA
	AND #$08
	BEQ +
	STZ !sprite_speed_y,x
+
	JSL $01802A|!BankB
	LDA !1588,x
	AND #$04
	BEQ +
	STZ !sprite_speed_x,x
+
	JSR check_mario
	LDA !state,x
	CMP #$05
	BNE +
	RTS
+
	%SubHorzPos()
	TYA
	STA !157C,x
	LDA !timer,x
	BNE +
	LDA #$10
	STA !timer,x
	DEC !state,x
	INC !hasami_flag,x
	LDA #$09
	STA !pose,x
	LDA !14E0,x
	XBA
	LDA !E4,x
	REP #$20
	SEC
	SBC $94
	STA $00
	SEP #$20

	LDA !14D4,x
	XBA
	LDA !D8,x
	REP #$20
	SEC
	SBC $96
	SEC
	SBC #$0018
	STA $02
	SEP #$20

	LDA #!kattaanohayasa
	%Aiming()

	LDA $02
	STA $03
	LDA $00
	STA $02
	STZ $00
	LDA #$F8
	STA $01
	LDA !new_sprite_num,x
	INC A
	SEC
	%SpawnSprite()
	TXA
	STA !C2,y
	LDA #$02
	STA !hasami_flag,x
	LDA #$03
	STA !state,x
	LDA #$20
	STA !timer,x
	LDA #$0A
	STA !pose,x
+
	RTS
;---------------------------------------------
x_tiwn:
	db $00,$18,$20,$18
	db $00,$E8,$E0,$E8
	db $00,$10,$00,$F0
y_tiwn:
	db $20,$18,$00,$E8
	db $E0,$E8,$00,$18
	db $10,$00,$F0,$00
deffert:
	LDA !timer,x
	BNE ++
	STZ !14C8,x
	%BES(+)
	LDA #$FF
	STA $1493|!Base2
	STA $0DDA|!Base2
	INC A
	STA $141C|!Base2
	DEC $13C6|!Base2
	LDA #$0B
	STA $1DFB|!Base2
	LDA #$01
	STA $13CE|!Base2
	RTS
+
	LDA #$06
	STA $71
	STZ $88
	STZ $89
++
	RTS
;---------------------------------------------
check_mario:
	LDA !muteki,x
	BEQ +
	RTS
+
	%CapeContact()
	BCC +
	LDA #!cape_power
	STA $00
	JMP mario_win
+
	%FireballContact()
	BCC +
	LDA #!fire_power
	STA $00
	JMP mario_win
+
	JSL $03B69F|!BankB
	LDY #!SprSize
-
	LDA !sprite_status,y
	CMP #$09
	BCC +
	PHX
	TYX
	JSL $03B6E5|!BankB
	PLX
	JSL $03B72B|!BankB
	BCC +
	LDA #$02
	STA !sprite_status,y
	LDA #$00
	STA !sprite_speed_x,y
	STA !sprite_speed_y,y
	LDA #!item_power
	STA $00
	JMP mario_win
+
	DEY
	BPL -
	
	JSL $01A7DC|!BankB
	BCC +
	LDA !hasami_flag,x
	CMP #$02
	BNE boss_win
	LDA #!jump_power
	STA $00
	%SubVertPos()
	LDA $0F
	CMP #$F0
	BPL boss_win
	LDA $7D
	BPL ++
boss_win:
	JSL $00F5B7|!BankB
+
	RTS
++
	JSL $01AA33|!BankB
	JSL $01AB99|!BankB
mario_win:
	LDA #$20
	STA !muteki,x
	LDA !C2,x
	SEC
	SBC $00
	STA !C2,x
	DEC
	BPL +
	STZ !C2,x

	LDA #$0B
	STA !anime_count,x
-
	LDA !anime_count,x
	TAY
	STZ $00
	STZ $01
	LDA x_tiwn,y
	STA $02
	LDA y_tiwn,y
	STA $03
	LDA !new_sprite_num,x
	DEC A
	SEC
	%SpawnSprite()
	PHX
	TYX
	LDA #$01
	STA !151C,x
	PLX
	LDA !anime_count,x
	DEC A
	STA !anime_count,x
	BPL -
	LDA #!taositekaranojikan
	STA !timer,x
	LDA #$05
	STA !state,x
	RTS
+
	LDA #$28
	STA $1DFC|!Base2
	RTS

x_pos:
	db $F8,$08,$F8,$08,$01 ;Stand1
	db $F8,$08,$F8,$08,$01 ;Stand2
	db $F8,$08,$F8,$08,$FD ;Walk1
	db $F8,$08,$F8,$08,$FD ;Walk2
	db $F8,$08,$F8,$08,$FD ;Walk3
	db $F8,$08,$F8,$08,$FD ;Walk4
	db $F8,$08,$F8,$08,$FD ;Walk5
	db $F8,$08,$F8,$08,$FD ;Walk6
	db $F8,$08,$F8,$08,$00 ;Jump
	db $F8,$08,$F8,$08,$01 ;CutterThrow1
	db $F5,$05,$F5,$05,$FE ;CutterThrow2
	db $FC,$FC,$04,$04     ;HitEffect
tilemap:
	db $00,$02,$20,$22,$55 ;Stand1
	db $04,$06,$24,$26,$55 ;Stand2
	db $08,$0A,$28,$2A,$55 ;Walk1
	db $0C,$0E,$2C,$2E,$55 ;Walk2
	db $40,$42,$60,$62,$55 ;Walk3
	db $44,$46,$64,$66,$55 ;Walk4
	db $48,$4A,$68,$6A,$55 ;Walk5
	db $4C,$4E,$6C,$6E,$55 ;Walk6
	db $80,$82,$84,$86,$55 ;Jump
	db $88,$8A,$8C,$8E,$55 ;CutterThrow1
	db $CC,$CE,$EC,$EE,$55 ;CutterThrow2
	db $D6,$E6,$D7,$E7     ;HitEffect
y_pos:
	db $F0,$F0,$00,$00,$E7 ;Stand1
	db $F0,$F0,$00,$00,$E7 ;Stand2
	db $F0,$F0,$00,$00,$E9 ;Walk1
	db $F0,$F0,$00,$00,$E6 ;Walk2
	db $F0,$F0,$00,$00,$E7 ;Walk3
	db $F0,$F0,$00,$00,$E9 ;Walk4
	db $F0,$F0,$00,$00,$E6 ;Walk5
	db $F0,$F0,$00,$00,$E7 ;Walk6
	db $F0,$F0,$00,$00,$E8 ;Jump
	db $F0,$F0,$00,$00,$E7 ;CutterThrow1
	db $F0,$F0,$00,$00,$E7 ;CutterThrow2
	db $F8,$00,$F8,$00     ;HitEffect
hasami_tile:
	db $A0,$C0
tile_addr:
	db $00,$05,$0A,$0F
	db $14,$19,$1E,$23
	db $28,$2D,$32,$37
gfx:
	LDA !state,x
	CMP #$05
	BNE +
	RTS
+
	%GetDrawInfo()
	LDA !157C,x
	EOR #$01
	ASL #6
	STA $02
	
	LDA !15F6,x
	STA $04
	

	PHX
	LDA !hasami_flag,x
	CMP #$02
	BCC +
	LDA #$03
	STA $05
	BRA ++
+
	TAX
	LDA hasami_tile,x
	STA $03
	LDA #$04
	STA $05
++
	PLX
	PHX
	LDA !muteki,x
	BEQ +
	LDA $14
	AND #$01
	BEQ +
	LDA #$03
	STA $05
	LDA #$0B
	BRA ++
+
	LDA !pose,x
++
	TAX
	LDA tile_addr,x
	STA $06
	LDX $05
-
	PHX
	TXA
	CLC
	ADC $06
	TAX
	
	LDA x_pos,x
	PHX
	LDX $02
	BEQ +
	EOR #$FF
	INC A
+
	PLX
	CLC
	ADC $00
	STA $0300|!Base2,y
	LDA tilemap,x
	CMP #$55
	BNE +
	LDA $03
+
	STA $0302|!Base2,y
	
	LDA y_pos,x
	CLC
	ADC $01
	STA $0301|!Base2,y
	
	LDA $04
	ORA $02
	ORA $64
	STA $0303|!Base2,y
	
	PLX
	INY #4
	DEX
	BPL -
	
	PLX
	LDY #$02
	LDA $05
	%FinishOAMWrite()
	RTS