;---------------------------------------------
;ローリングカッター
;---------------------------------------------
!modoruhayasa = $20
;---------------------------------------------
print "INIT ",pc
	RTL
;---------------------------------------------
print "MAIN ",pc
	PHB
	PHK
	PLB
	JSR MainCode
	PLB
	RTL
;---------------------------------------------
MainCode:
	JSR Graphics
	LDA #$00
	%SubOffScreen()
	
	LDA $9D
	BNE Return
	LDA !14C8,x
	CMP #$08
	BNE Return

	JSL $01A7DC|!BankB
	LDA !1504,x
	BNE ++
	JSL $019138|!BankB
	LDA !1588,x
	AND #$0F
	BEQ +
	LDA #$01
	STA !1504,x
+
	JSL $01801A|!BankB
	JSL $018022|!BankB
Return:
	RTS
++
	LDA !sprite_x_high,x
	XBA
	LDA !sprite_x_low,x
	REP #$20
	STA $00
	SEP #$20

	LDA !sprite_y_high,x
	XBA
	LDA !sprite_y_low,x
	REP #$20
	STA $02
	SEP #$20

	PHX
	LDA !C2,x
	TAX

	LDA !sprite_x_high,x
	XBA
	LDA !sprite_x_low,x
	REP #$20
	SEC
	SBC $00
	EOR #$FFFF
	INC A
	STA $00
	SEP #$20

	LDA !sprite_y_high,x
	XBA
	LDA !sprite_y_low,x
	REP #$20
	SEC
	SBC $02
	EOR #$FFFF
	INC A
	STA $02
	SEP #$20
	
	LDA #!modoruhayasa
	%Aiming()
	PLX
	LDA $00
	STA !sprite_speed_x,x
	LDA $02
	STA !sprite_speed_y,x

	JSL $01801A|!BankB
	JSL $018022|!BankB
	JSL $03B69F|!BankB
	PHX
	LDA !C2,x
	TAX
	JSL $03B6E5|!BankB
	PLX
	JSL $03B72B|!BankB
	BCC +
	PHX
	LDA !C2,x
	TAX
	STZ !151C,x
	PLX
	STZ !sprite_status,x
+
	RTS

;---------------------------------------------
tilemap:
	db $AA,$AE,$AA,$AE
Properties:
	db $00,$00,$C0,$C0

Graphics:
	LDA $14
	LSR #2
	AND #$03
	TAY
	LDA tilemap,y
	STA $02
	LDA Properties,y
	STA $03

	%GetDrawInfo()
	LDA $00
	STA $0300|!Base2,y
	LDA $01
	DEC A
	STA $0301|!Base2,y
	LDA $02
	STA $0302|!Base2,y
	LDA !15F6,x
	ORA $03
	ORA $64
	STA $0303|!Base2,y
	LDY #$02
	LDA #$00
	JSL $01B7B3|!BankB
	RTS